"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.appliance_image_bundle_all_of import ApplianceImageBundleAllOf
    from intersight.model.display_names import DisplayNames
    from intersight.model.mo_base_mo import MoBaseMo
    from intersight.model.mo_base_mo_relationship import MoBaseMoRelationship
    from intersight.model.mo_tag import MoTag
    from intersight.model.mo_version_context import MoVersionContext
    from intersight.model.onprem_image_package import OnpremImagePackage
    globals()['ApplianceImageBundleAllOf'] = ApplianceImageBundleAllOf
    globals()['DisplayNames'] = DisplayNames
    globals()['MoBaseMo'] = MoBaseMo
    globals()['MoBaseMoRelationship'] = MoBaseMoRelationship
    globals()['MoTag'] = MoTag
    globals()['MoVersionContext'] = MoVersionContext
    globals()['OnpremImagePackage'] = OnpremImagePackage


class ApplianceImageBundle(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'APPLIANCE.IMAGEBUNDLE': "appliance.ImageBundle",
        },
        ('object_type',): {
            'APPLIANCE.IMAGEBUNDLE': "appliance.ImageBundle",
        },
        ('priority',): {
            'NORMAL': "Normal",
            'CRITICAL': "Critical",
        },
        ('upgrade_impact_enum',): {
            'NONE': "None",
            'DISRUPTIVE': "Disruptive",
            'DISRUPTIVE-REBOOT': "Disruptive-reboot",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'ansible_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'auto_upgrade': (bool,),  # noqa: E501
            'dc_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'debug_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'endpoint_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'fingerprint': (str,),  # noqa: E501
            'has_error': (bool,),  # noqa: E501
            'infra_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'init_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'notes': (str,),  # noqa: E501
            'priority': (str,),  # noqa: E501
            'release_time': (datetime,),  # noqa: E501
            'service_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'status_message': (str,),  # noqa: E501
            'system_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'ui_packages': ([OnpremImagePackage], none_type,),  # noqa: E501
            'upgrade_end_time': (datetime,),  # noqa: E501
            'upgrade_grace_period': (int,),  # noqa: E501
            'upgrade_impact_duration': (int,),  # noqa: E501
            'upgrade_impact_enum': (str,),  # noqa: E501
            'upgrade_start_time': (datetime,),  # noqa: E501
            'version': (str,),  # noqa: E501
            'account_moid': (str,),  # noqa: E501
            'create_time': (datetime,),  # noqa: E501
            'domain_group_moid': (str,),  # noqa: E501
            'mod_time': (datetime,),  # noqa: E501
            'moid': (str,),  # noqa: E501
            'owners': ([str], none_type,),  # noqa: E501
            'shared_scope': (str,),  # noqa: E501
            'tags': ([MoTag], none_type,),  # noqa: E501
            'version_context': (MoVersionContext,),  # noqa: E501
            'ancestors': ([MoBaseMoRelationship], none_type,),  # noqa: E501
            'parent': (MoBaseMoRelationship,),  # noqa: E501
            'permission_resources': ([MoBaseMoRelationship], none_type,),  # noqa: E501
            'display_names': (DisplayNames,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        val = {
        }
        if not val:
            return None
        return {'class_id': val}

    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'ansible_packages': 'AnsiblePackages',  # noqa: E501
        'auto_upgrade': 'AutoUpgrade',  # noqa: E501
        'dc_packages': 'DcPackages',  # noqa: E501
        'debug_packages': 'DebugPackages',  # noqa: E501
        'description': 'Description',  # noqa: E501
        'endpoint_packages': 'EndpointPackages',  # noqa: E501
        'fingerprint': 'Fingerprint',  # noqa: E501
        'has_error': 'HasError',  # noqa: E501
        'infra_packages': 'InfraPackages',  # noqa: E501
        'init_packages': 'InitPackages',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'notes': 'Notes',  # noqa: E501
        'priority': 'Priority',  # noqa: E501
        'release_time': 'ReleaseTime',  # noqa: E501
        'service_packages': 'ServicePackages',  # noqa: E501
        'status_message': 'StatusMessage',  # noqa: E501
        'system_packages': 'SystemPackages',  # noqa: E501
        'ui_packages': 'UiPackages',  # noqa: E501
        'upgrade_end_time': 'UpgradeEndTime',  # noqa: E501
        'upgrade_grace_period': 'UpgradeGracePeriod',  # noqa: E501
        'upgrade_impact_duration': 'UpgradeImpactDuration',  # noqa: E501
        'upgrade_impact_enum': 'UpgradeImpactEnum',  # noqa: E501
        'upgrade_start_time': 'UpgradeStartTime',  # noqa: E501
        'version': 'Version',  # noqa: E501
        'account_moid': 'AccountMoid',  # noqa: E501
        'create_time': 'CreateTime',  # noqa: E501
        'domain_group_moid': 'DomainGroupMoid',  # noqa: E501
        'mod_time': 'ModTime',  # noqa: E501
        'moid': 'Moid',  # noqa: E501
        'owners': 'Owners',  # noqa: E501
        'shared_scope': 'SharedScope',  # noqa: E501
        'tags': 'Tags',  # noqa: E501
        'version_context': 'VersionContext',  # noqa: E501
        'ancestors': 'Ancestors',  # noqa: E501
        'parent': 'Parent',  # noqa: E501
        'permission_resources': 'PermissionResources',  # noqa: E501
        'display_names': 'DisplayNames',  # noqa: E501
    }

    read_only_vars = {
        'auto_upgrade',  # noqa: E501
        'description',  # noqa: E501
        'fingerprint',  # noqa: E501
        'has_error',  # noqa: E501
        'name',  # noqa: E501
        'notes',  # noqa: E501
        'priority',  # noqa: E501
        'release_time',  # noqa: E501
        'status_message',  # noqa: E501
        'upgrade_end_time',  # noqa: E501
        'upgrade_grace_period',  # noqa: E501
        'upgrade_impact_duration',  # noqa: E501
        'upgrade_impact_enum',  # noqa: E501
        'upgrade_start_time',  # noqa: E501
        'version',  # noqa: E501
        'account_moid',  # noqa: E501
        'create_time',  # noqa: E501
        'domain_group_moid',  # noqa: E501
        'mod_time',  # noqa: E501
        'shared_scope',  # noqa: E501
        'ancestors',  # noqa: E501
        'permission_resources',  # noqa: E501
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """ApplianceImageBundle - a model defined in OpenAPI

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "appliance.ImageBundle", must be one of ["appliance.ImageBundle", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "appliance.ImageBundle", must be one of ["appliance.ImageBundle", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            ansible_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            auto_upgrade (bool): Indicates that the software upgrade was automatically initiated by the Intersight Appliance.. [optional]  # noqa: E501
            dc_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            debug_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            description (str): Short description of the software upgrade bundle.. [optional]  # noqa: E501
            endpoint_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            fingerprint (str): Fingerprint of the software manifest from which this bundle is created. Fingerprint is calculated using the SHA256 algorithm.. [optional]  # noqa: E501
            has_error (bool): Indicates that the ImageBundle has errors. The upgrade service sets this field when it encounters errors during the manifest processing.. [optional]  # noqa: E501
            infra_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            init_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            name (str): Name of the software upgrade bundle.. [optional]  # noqa: E501
            notes (str): Detailed description of the software upgrade bundle.. [optional]  # noqa: E501
            priority (str): Software upgrade manifest's upgrade priority. The upgrade service supports two priorities, Normal and Critical. Normal priority is used for regular software upgrades, and the upgrade service uses the Upgrade Policy to compute upgrade start time. Critical priority is used for the critical software security patches, and the upgrade service ignores the Upgrade Policy when it computes the upgrade start time. * `Normal` - Normal upgrade priority is used for all the software upgrades except for the critical security updates. The upgrade service of Intersight Appliance uses the Software Upgrade Policy settings to start the upgrade process. * `Critical` - Critical upgrade priority is used for critical updates such as security patches. The upgrade service of the Intersight Appliance starts the upgrade as specified by the upgrade properties in the software manifest file. The upgrade service will not use the settings specified in the Software Upgrade Policy.. [optional] if omitted the server will use the default value of "Normal"  # noqa: E501
            release_time (datetime): Software upgrade manifest's release date and time.. [optional]  # noqa: E501
            service_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            status_message (str): Status message set during the manifest processing.. [optional]  # noqa: E501
            system_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            ui_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            upgrade_end_time (datetime): End date of the software upgrade process.. [optional]  # noqa: E501
            upgrade_grace_period (int): Grace period in seconds before the automatic upgrade is initiated. The upgrade service uses the grace period to compute the upgrade start time when it receives an upgrade notfication from the Intersight. If there is an Upgrade Policy configured for the Intersight Appliance, then the upgrade service uses the policy to compute the upgrade start time. However, the upgrade start time cannot not exceed the limit enforced by the grace period.. [optional]  # noqa: E501
            upgrade_impact_duration (int): Duration (in minutes) for which services will be disrupted.. [optional] if omitted the server will use the default value of 0  # noqa: E501
            upgrade_impact_enum (str): UpgradeImpactEnum is used to indicate the kind of impact the upgrade has on currently running services on the appliance. * `None` - The upgrade has no effect on the system. * `Disruptive` - The services will not be functional during the upgrade. * `Disruptive-reboot` - The upgrade needs a reboot.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            upgrade_start_time (datetime): Start date of the software upgrade process.. [optional]  # noqa: E501
            version (str): Software upgrade manifest's version.. [optional]  # noqa: E501
            account_moid (str): The Account ID for this managed object.. [optional]  # noqa: E501
            create_time (datetime): The time when this managed object was created.. [optional]  # noqa: E501
            domain_group_moid (str): The DomainGroup ID for this managed object.. [optional]  # noqa: E501
            mod_time (datetime): The time when this managed object was last modified.. [optional]  # noqa: E501
            moid (str): The unique identifier of this Managed Object instance.. [optional]  # noqa: E501
            owners ([str], none_type): [optional]  # noqa: E501
            shared_scope (str): Intersight provides pre-built workflows, tasks and policies to end users through global catalogs. Objects that are made available through global catalogs are said to have a 'shared' ownership. Shared objects are either made globally available to all end users or restricted to end users based on their license entitlement. Users can use this property to differentiate the scope (global or a specific license tier) to which a shared MO belongs.. [optional]  # noqa: E501
            tags ([MoTag], none_type): [optional]  # noqa: E501
            version_context (MoVersionContext): [optional]  # noqa: E501
            ancestors ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            parent (MoBaseMoRelationship): [optional]  # noqa: E501
            permission_resources ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            display_names (DisplayNames): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "appliance.ImageBundle")
        object_type = kwargs.get('object_type', "appliance.ImageBundle")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        kwargs.update(required_args)
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ApplianceImageBundle - a model defined in OpenAPI

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "appliance.ImageBundle", must be one of ["appliance.ImageBundle", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "appliance.ImageBundle", must be one of ["appliance.ImageBundle", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            ansible_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            auto_upgrade (bool): Indicates that the software upgrade was automatically initiated by the Intersight Appliance.. [optional]  # noqa: E501
            dc_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            debug_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            description (str): Short description of the software upgrade bundle.. [optional]  # noqa: E501
            endpoint_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            fingerprint (str): Fingerprint of the software manifest from which this bundle is created. Fingerprint is calculated using the SHA256 algorithm.. [optional]  # noqa: E501
            has_error (bool): Indicates that the ImageBundle has errors. The upgrade service sets this field when it encounters errors during the manifest processing.. [optional]  # noqa: E501
            infra_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            init_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            name (str): Name of the software upgrade bundle.. [optional]  # noqa: E501
            notes (str): Detailed description of the software upgrade bundle.. [optional]  # noqa: E501
            priority (str): Software upgrade manifest's upgrade priority. The upgrade service supports two priorities, Normal and Critical. Normal priority is used for regular software upgrades, and the upgrade service uses the Upgrade Policy to compute upgrade start time. Critical priority is used for the critical software security patches, and the upgrade service ignores the Upgrade Policy when it computes the upgrade start time. * `Normal` - Normal upgrade priority is used for all the software upgrades except for the critical security updates. The upgrade service of Intersight Appliance uses the Software Upgrade Policy settings to start the upgrade process. * `Critical` - Critical upgrade priority is used for critical updates such as security patches. The upgrade service of the Intersight Appliance starts the upgrade as specified by the upgrade properties in the software manifest file. The upgrade service will not use the settings specified in the Software Upgrade Policy.. [optional] if omitted the server will use the default value of "Normal"  # noqa: E501
            release_time (datetime): Software upgrade manifest's release date and time.. [optional]  # noqa: E501
            service_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            status_message (str): Status message set during the manifest processing.. [optional]  # noqa: E501
            system_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            ui_packages ([OnpremImagePackage], none_type): [optional]  # noqa: E501
            upgrade_end_time (datetime): End date of the software upgrade process.. [optional]  # noqa: E501
            upgrade_grace_period (int): Grace period in seconds before the automatic upgrade is initiated. The upgrade service uses the grace period to compute the upgrade start time when it receives an upgrade notfication from the Intersight. If there is an Upgrade Policy configured for the Intersight Appliance, then the upgrade service uses the policy to compute the upgrade start time. However, the upgrade start time cannot not exceed the limit enforced by the grace period.. [optional]  # noqa: E501
            upgrade_impact_duration (int): Duration (in minutes) for which services will be disrupted.. [optional] if omitted the server will use the default value of 0  # noqa: E501
            upgrade_impact_enum (str): UpgradeImpactEnum is used to indicate the kind of impact the upgrade has on currently running services on the appliance. * `None` - The upgrade has no effect on the system. * `Disruptive` - The services will not be functional during the upgrade. * `Disruptive-reboot` - The upgrade needs a reboot.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            upgrade_start_time (datetime): Start date of the software upgrade process.. [optional]  # noqa: E501
            version (str): Software upgrade manifest's version.. [optional]  # noqa: E501
            account_moid (str): The Account ID for this managed object.. [optional]  # noqa: E501
            create_time (datetime): The time when this managed object was created.. [optional]  # noqa: E501
            domain_group_moid (str): The DomainGroup ID for this managed object.. [optional]  # noqa: E501
            mod_time (datetime): The time when this managed object was last modified.. [optional]  # noqa: E501
            moid (str): The unique identifier of this Managed Object instance.. [optional]  # noqa: E501
            owners ([str], none_type): [optional]  # noqa: E501
            shared_scope (str): Intersight provides pre-built workflows, tasks and policies to end users through global catalogs. Objects that are made available through global catalogs are said to have a 'shared' ownership. Shared objects are either made globally available to all end users or restricted to end users based on their license entitlement. Users can use this property to differentiate the scope (global or a specific license tier) to which a shared MO belongs.. [optional]  # noqa: E501
            tags ([MoTag], none_type): [optional]  # noqa: E501
            version_context (MoVersionContext): [optional]  # noqa: E501
            ancestors ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            parent (MoBaseMoRelationship): [optional]  # noqa: E501
            permission_resources ([MoBaseMoRelationship], none_type): An array of relationships to moBaseMo resources.. [optional]  # noqa: E501
            display_names (DisplayNames): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "appliance.ImageBundle")
        object_type = kwargs.get('object_type', "appliance.ImageBundle")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        kwargs.update(required_args)
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              ApplianceImageBundleAllOf,
              MoBaseMo,
          ],
          'oneOf': [
          ],
        }
