"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.asset_customer_information import AssetCustomerInformation
    from intersight.model.asset_device_transaction import AssetDeviceTransaction
    globals()['AssetCustomerInformation'] = AssetCustomerInformation
    globals()['AssetDeviceTransaction'] = AssetDeviceTransaction


class AssetDeviceInformationAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'ASSET.DEVICEINFORMATION': "asset.DeviceInformation",
        },
        ('object_type',): {
            'ASSET.DEVICEINFORMATION': "asset.DeviceInformation",
        },
        ('old_device_status_id',): {
            '0': 0,
            '10000': 10000,
            '1010041': 1010041,
            '10005': 10005,
            '10007': 10007,
            '10009': 10009,
        },
        ('unit_of_measure',): {
            'NONE': "None",
            'STORAGE': "STORAGE",
            'NODE': "NODE",
            'VM': "VM",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'application_name': (str,),  # noqa: E501
            'device_transactions': ([AssetDeviceTransaction], none_type,),  # noqa: E501
            'end_customer': (AssetCustomerInformation,),  # noqa: E501
            'instance_id': (str,),  # noqa: E501
            'item_type': (str,),  # noqa: E501
            'mlb_offer_type': (str,),  # noqa: E501
            'mlb_product_id': (int,),  # noqa: E501
            'mlb_product_name': (str,),  # noqa: E501
            'old_device_id': (str,),  # noqa: E501
            'old_device_status_description': (str,),  # noqa: E501
            'old_device_status_id': (int,),  # noqa: E501
            'old_instance_id': (str,),  # noqa: E501
            'product_family': (str,),  # noqa: E501
            'product_type': (str,),  # noqa: E501
            'unit_of_measure': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'application_name': 'ApplicationName',  # noqa: E501
        'device_transactions': 'DeviceTransactions',  # noqa: E501
        'end_customer': 'EndCustomer',  # noqa: E501
        'instance_id': 'InstanceId',  # noqa: E501
        'item_type': 'ItemType',  # noqa: E501
        'mlb_offer_type': 'MlbOfferType',  # noqa: E501
        'mlb_product_id': 'MlbProductId',  # noqa: E501
        'mlb_product_name': 'MlbProductName',  # noqa: E501
        'old_device_id': 'OldDeviceId',  # noqa: E501
        'old_device_status_description': 'OldDeviceStatusDescription',  # noqa: E501
        'old_device_status_id': 'OldDeviceStatusId',  # noqa: E501
        'old_instance_id': 'OldInstanceId',  # noqa: E501
        'product_family': 'ProductFamily',  # noqa: E501
        'product_type': 'ProductType',  # noqa: E501
        'unit_of_measure': 'UnitOfMeasure',  # noqa: E501
    }

    read_only_vars = {
        'application_name',  # noqa: E501
        'instance_id',  # noqa: E501
        'item_type',  # noqa: E501
        'mlb_offer_type',  # noqa: E501
        'mlb_product_id',  # noqa: E501
        'mlb_product_name',  # noqa: E501
        'old_device_id',  # noqa: E501
        'old_device_status_description',  # noqa: E501
        'old_device_status_id',  # noqa: E501
        'old_instance_id',  # noqa: E501
        'product_family',  # noqa: E501
        'product_type',  # noqa: E501
        'unit_of_measure',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """AssetDeviceInformationAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "asset.DeviceInformation", must be one of ["asset.DeviceInformation", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "asset.DeviceInformation", must be one of ["asset.DeviceInformation", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            application_name (str): Application name reported by Cisco Install Base.. [optional]  # noqa: E501
            device_transactions ([AssetDeviceTransaction], none_type): [optional]  # noqa: E501
            end_customer (AssetCustomerInformation): [optional]  # noqa: E501
            instance_id (str): Instance number of the device. example \"917280220\".. [optional]  # noqa: E501
            item_type (str): Item type flag. example ATO, Child, Standalone. ATO - refers to Cisco Block based major device. Child - refers to Child device part of an ATO block. Standalone - refers to a device that is managed and configured as an individual entity with limited capacity.. [optional]  # noqa: E501
            mlb_offer_type (str): Identifier for consumption based pricing. MLB refers to MultiLine Bundle.. [optional]  # noqa: E501
            mlb_product_id (int): Identifier corresponding to MLB Product Name. MLB refers to MultiLine Bundle.. [optional]  # noqa: E501
            mlb_product_name (str): Product Name for the device. It is used to determine if the server is to be billed as a UCS compute device or a storage cluster. MLB refers to MultiLine Bundle.. [optional]  # noqa: E501
            old_device_id (str): Unique identifier of old Cisco device. It is the device ID of old Cisco device, which got replaced by the new device.. [optional]  # noqa: E501
            old_device_status_description (str): Description of status of old Cisco device, which got replaced by the new device.. [optional]  # noqa: E501
            old_device_status_id (int): Status ID of old Cisco device, which got replaced by the new device. * `0` - A default value to catch cases where device status is not correctly detected. * `10000` - Device is installed successfully. * `1010041` - Device is currently in Return Material Authorization process. * `10005` - Device is replaced successfully with another device. * `10007` - Device is returned succcessfuly. * `10009` - Device is terminated at customer's end.. [optional] if omitted the server will use the default value of 0  # noqa: E501
            old_instance_id (str): Instance number of the old device, which got replaced by the new device.. [optional]  # noqa: E501
            product_family (str): Product Family is the field used to identify the hypervisor type. example \"ESXi\".. [optional]  # noqa: E501
            product_type (str): Product type helps to determine if device has to be billed using consumption metering. example \"SERVER\".. [optional]  # noqa: E501
            unit_of_measure (str): Unit of Measure is flag used to identify the type of metric being pushed. example - \"STORAGE\" for hardware metrics , \"VM\" - for hypervisor metrics. * `None` - A default value to catch cases where unit of measure is not correctly detected. * `STORAGE` - The metric type of the device is a storage metric. * `NODE` - The metric type of the device is a hardware metric. * `VM` - The metric type of the device is a hypervisor metric.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
        """

        class_id = kwargs.get('class_id', "asset.DeviceInformation")
        object_type = kwargs.get('object_type', "asset.DeviceInformation")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """AssetDeviceInformationAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "asset.DeviceInformation", must be one of ["asset.DeviceInformation", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "asset.DeviceInformation", must be one of ["asset.DeviceInformation", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            application_name (str): Application name reported by Cisco Install Base.. [optional]  # noqa: E501
            device_transactions ([AssetDeviceTransaction], none_type): [optional]  # noqa: E501
            end_customer (AssetCustomerInformation): [optional]  # noqa: E501
            instance_id (str): Instance number of the device. example \"917280220\".. [optional]  # noqa: E501
            item_type (str): Item type flag. example ATO, Child, Standalone. ATO - refers to Cisco Block based major device. Child - refers to Child device part of an ATO block. Standalone - refers to a device that is managed and configured as an individual entity with limited capacity.. [optional]  # noqa: E501
            mlb_offer_type (str): Identifier for consumption based pricing. MLB refers to MultiLine Bundle.. [optional]  # noqa: E501
            mlb_product_id (int): Identifier corresponding to MLB Product Name. MLB refers to MultiLine Bundle.. [optional]  # noqa: E501
            mlb_product_name (str): Product Name for the device. It is used to determine if the server is to be billed as a UCS compute device or a storage cluster. MLB refers to MultiLine Bundle.. [optional]  # noqa: E501
            old_device_id (str): Unique identifier of old Cisco device. It is the device ID of old Cisco device, which got replaced by the new device.. [optional]  # noqa: E501
            old_device_status_description (str): Description of status of old Cisco device, which got replaced by the new device.. [optional]  # noqa: E501
            old_device_status_id (int): Status ID of old Cisco device, which got replaced by the new device. * `0` - A default value to catch cases where device status is not correctly detected. * `10000` - Device is installed successfully. * `1010041` - Device is currently in Return Material Authorization process. * `10005` - Device is replaced successfully with another device. * `10007` - Device is returned succcessfuly. * `10009` - Device is terminated at customer's end.. [optional] if omitted the server will use the default value of 0  # noqa: E501
            old_instance_id (str): Instance number of the old device, which got replaced by the new device.. [optional]  # noqa: E501
            product_family (str): Product Family is the field used to identify the hypervisor type. example \"ESXi\".. [optional]  # noqa: E501
            product_type (str): Product type helps to determine if device has to be billed using consumption metering. example \"SERVER\".. [optional]  # noqa: E501
            unit_of_measure (str): Unit of Measure is flag used to identify the type of metric being pushed. example - \"STORAGE\" for hardware metrics , \"VM\" - for hypervisor metrics. * `None` - A default value to catch cases where unit of measure is not correctly detected. * `STORAGE` - The metric type of the device is a storage metric. * `NODE` - The metric type of the device is a hardware metric. * `VM` - The metric type of the device is a hypervisor metric.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
        """

        class_id = kwargs.get('class_id', "asset.DeviceInformation")
        object_type = kwargs.get('object_type', "asset.DeviceInformation")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
