"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError



class CloudSkuInstanceTypeAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'CLOUD.SKUINSTANCETYPE': "cloud.SkuInstanceType",
        },
        ('object_type',): {
            'CLOUD.SKUINSTANCETYPE': "cloud.SkuInstanceType",
        },
        ('architecture_type',): {
            '64BIT': "64Bit",
            '32BIT': "32Bit",
            'BOTH': "both",
        },
        ('cpu_unit',): {
            'VIRTUAL_CPU': "VIRTUAL_CPU",
            'MILLI_CPU': "MILLI_CPU",
        },
        ('local_storage_size_unit',): {
            'MB': "MB",
            'GB': "GB",
            'TB': "TB",
        },
        ('memory_size_unit',): {
            'MB': "MB",
            'GB': "GB",
            'TB': "TB",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'architecture_type': (str,),  # noqa: E501
            'cpu_unit': (str,),  # noqa: E501
            'cuda_support': (bool,),  # noqa: E501
            'local_storage_size': (float,),  # noqa: E501
            'local_storage_size_unit': (str,),  # noqa: E501
            'memory_size': (float,),  # noqa: E501
            'memory_size_unit': (str,),  # noqa: E501
            'network_performance': (str,),  # noqa: E501
            'num_of_cpus': (int,),  # noqa: E501
            'num_of_nics': (int,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'architecture_type': 'ArchitectureType',  # noqa: E501
        'cpu_unit': 'CpuUnit',  # noqa: E501
        'cuda_support': 'CudaSupport',  # noqa: E501
        'local_storage_size': 'LocalStorageSize',  # noqa: E501
        'local_storage_size_unit': 'LocalStorageSizeUnit',  # noqa: E501
        'memory_size': 'MemorySize',  # noqa: E501
        'memory_size_unit': 'MemorySizeUnit',  # noqa: E501
        'network_performance': 'NetworkPerformance',  # noqa: E501
        'num_of_cpus': 'NumOfCpus',  # noqa: E501
        'num_of_nics': 'NumOfNics',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """CloudSkuInstanceTypeAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "cloud.SkuInstanceType", must be one of ["cloud.SkuInstanceType", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "cloud.SkuInstanceType", must be one of ["cloud.SkuInstanceType", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            architecture_type (str): Indicates if the instance type supports 32 or 64 bit or both. * `64Bit` - Enum to indicate that the instance type suppports only 64 bit architecture. * `32Bit` - Enum to indicate that the instance type supports only 32 bit architecture. * `both` - Enum to indicate that the instance type supports both 32 and 64 bit architecture.. [optional] if omitted the server will use the default value of "64Bit"  # noqa: E501
            cpu_unit (str): The cpu unit for this instance type. * `VIRTUAL_CPU` - The CPU unit used for virtual machines. * `MILLI_CPU` - The CPU unit used by containers.. [optional] if omitted the server will use the default value of "VIRTUAL_CPU"  # noqa: E501
            cuda_support (bool): Does the instanceType support CUDA architecture.. [optional]  # noqa: E501
            local_storage_size (float): Total size of local storage for this instance type.. [optional]  # noqa: E501
            local_storage_size_unit (str): The units for this storage. For e.g. MB or GB or TB. * `MB` - Enum to represent mega byte storage unit. * `GB` - Enum to represent Giga byte storage unit. * `TB` - Enum to represent Tera byte storage unit.. [optional] if omitted the server will use the default value of "MB"  # noqa: E501
            memory_size (float): The RAM size for this instance type.. [optional]  # noqa: E501
            memory_size_unit (str): Units to represent memory, for e.g. MB or GB. * `MB` - Enum to represent mega byte storage unit. * `GB` - Enum to represent Giga byte storage unit. * `TB` - Enum to represent Tera byte storage unit.. [optional] if omitted the server will use the default value of "MB"  # noqa: E501
            network_performance (str): Network performance of this instance type.. [optional]  # noqa: E501
            num_of_cpus (int): The number of CPUs in this instance type.. [optional]  # noqa: E501
            num_of_nics (int): Maximum number of NICs supported by this instance type.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "cloud.SkuInstanceType")
        object_type = kwargs.get('object_type', "cloud.SkuInstanceType")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CloudSkuInstanceTypeAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "cloud.SkuInstanceType", must be one of ["cloud.SkuInstanceType", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "cloud.SkuInstanceType", must be one of ["cloud.SkuInstanceType", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            architecture_type (str): Indicates if the instance type supports 32 or 64 bit or both. * `64Bit` - Enum to indicate that the instance type suppports only 64 bit architecture. * `32Bit` - Enum to indicate that the instance type supports only 32 bit architecture. * `both` - Enum to indicate that the instance type supports both 32 and 64 bit architecture.. [optional] if omitted the server will use the default value of "64Bit"  # noqa: E501
            cpu_unit (str): The cpu unit for this instance type. * `VIRTUAL_CPU` - The CPU unit used for virtual machines. * `MILLI_CPU` - The CPU unit used by containers.. [optional] if omitted the server will use the default value of "VIRTUAL_CPU"  # noqa: E501
            cuda_support (bool): Does the instanceType support CUDA architecture.. [optional]  # noqa: E501
            local_storage_size (float): Total size of local storage for this instance type.. [optional]  # noqa: E501
            local_storage_size_unit (str): The units for this storage. For e.g. MB or GB or TB. * `MB` - Enum to represent mega byte storage unit. * `GB` - Enum to represent Giga byte storage unit. * `TB` - Enum to represent Tera byte storage unit.. [optional] if omitted the server will use the default value of "MB"  # noqa: E501
            memory_size (float): The RAM size for this instance type.. [optional]  # noqa: E501
            memory_size_unit (str): Units to represent memory, for e.g. MB or GB. * `MB` - Enum to represent mega byte storage unit. * `GB` - Enum to represent Giga byte storage unit. * `TB` - Enum to represent Tera byte storage unit.. [optional] if omitted the server will use the default value of "MB"  # noqa: E501
            network_performance (str): Network performance of this instance type.. [optional]  # noqa: E501
            num_of_cpus (int): The number of CPUs in this instance type.. [optional]  # noqa: E501
            num_of_nics (int): Maximum number of NICs supported by this instance type.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "cloud.SkuInstanceType")
        object_type = kwargs.get('object_type', "cloud.SkuInstanceType")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
