"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.asset_device_registration_relationship import AssetDeviceRegistrationRelationship
    from intersight.model.cond_alarm_definition_relationship import CondAlarmDefinitionRelationship
    from intersight.model.mo_base_mo_relationship import MoBaseMoRelationship
    globals()['AssetDeviceRegistrationRelationship'] = AssetDeviceRegistrationRelationship
    globals()['CondAlarmDefinitionRelationship'] = CondAlarmDefinitionRelationship
    globals()['MoBaseMoRelationship'] = MoBaseMoRelationship


class CondAlarmAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'COND.ALARM': "cond.Alarm",
        },
        ('object_type',): {
            'COND.ALARM': "cond.Alarm",
        },
        ('acknowledge',): {
            'NONE': "None",
            'ACKNOWLEDGE': "Acknowledge",
        },
        ('orig_severity',): {
            'NONE': "None",
            'INFO': "Info",
            'CRITICAL': "Critical",
            'WARNING': "Warning",
            'CLEARED': "Cleared",
        },
        ('severity',): {
            'NONE': "None",
            'INFO': "Info",
            'CRITICAL': "Critical",
            'WARNING': "Warning",
            'CLEARED': "Cleared",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'acknowledge': (str,),  # noqa: E501
            'acknowledge_by': (str,),  # noqa: E501
            'acknowledge_time': (datetime,),  # noqa: E501
            'affected_mo_display_name': (str,),  # noqa: E501
            'affected_mo_id': (str,),  # noqa: E501
            'affected_mo_type': (str,),  # noqa: E501
            'affected_object': (str,),  # noqa: E501
            'ancestor_mo_id': (str,),  # noqa: E501
            'ancestor_mo_type': (str,),  # noqa: E501
            'code': (str,),  # noqa: E501
            'creation_time': (datetime,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'last_transition_time': (datetime,),  # noqa: E501
            'ms_affected_object': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'orig_severity': (str,),  # noqa: E501
            'severity': (str,),  # noqa: E501
            'suppressed': (bool,),  # noqa: E501
            'affected_mo': (MoBaseMoRelationship,),  # noqa: E501
            'definition': (CondAlarmDefinitionRelationship,),  # noqa: E501
            'registered_device': (AssetDeviceRegistrationRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'acknowledge': 'Acknowledge',  # noqa: E501
        'acknowledge_by': 'AcknowledgeBy',  # noqa: E501
        'acknowledge_time': 'AcknowledgeTime',  # noqa: E501
        'affected_mo_display_name': 'AffectedMoDisplayName',  # noqa: E501
        'affected_mo_id': 'AffectedMoId',  # noqa: E501
        'affected_mo_type': 'AffectedMoType',  # noqa: E501
        'affected_object': 'AffectedObject',  # noqa: E501
        'ancestor_mo_id': 'AncestorMoId',  # noqa: E501
        'ancestor_mo_type': 'AncestorMoType',  # noqa: E501
        'code': 'Code',  # noqa: E501
        'creation_time': 'CreationTime',  # noqa: E501
        'description': 'Description',  # noqa: E501
        'last_transition_time': 'LastTransitionTime',  # noqa: E501
        'ms_affected_object': 'MsAffectedObject',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'orig_severity': 'OrigSeverity',  # noqa: E501
        'severity': 'Severity',  # noqa: E501
        'suppressed': 'Suppressed',  # noqa: E501
        'affected_mo': 'AffectedMo',  # noqa: E501
        'definition': 'Definition',  # noqa: E501
        'registered_device': 'RegisteredDevice',  # noqa: E501
    }

    read_only_vars = {
        'acknowledge_by',  # noqa: E501
        'acknowledge_time',  # noqa: E501
        'affected_mo_display_name',  # noqa: E501
        'affected_mo_id',  # noqa: E501
        'affected_mo_type',  # noqa: E501
        'affected_object',  # noqa: E501
        'ancestor_mo_id',  # noqa: E501
        'ancestor_mo_type',  # noqa: E501
        'code',  # noqa: E501
        'creation_time',  # noqa: E501
        'description',  # noqa: E501
        'last_transition_time',  # noqa: E501
        'ms_affected_object',  # noqa: E501
        'name',  # noqa: E501
        'orig_severity',  # noqa: E501
        'severity',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """CondAlarmAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "cond.Alarm", must be one of ["cond.Alarm", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "cond.Alarm", must be one of ["cond.Alarm", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            acknowledge (str): Alarm acknowledgment state. Default value is None. * `None` - The Enum value None represents that the alarm is not acknowledged and is included as part of health status and overall alarm count. * `Acknowledge` - The Enum value Acknowledge represents that the alarm is acknowledged by user. The alarm will be ignored from the health status and overall alarm count.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            acknowledge_by (str): User who acknowledged the alarm.. [optional]  # noqa: E501
            acknowledge_time (datetime): Time at which the alarm was acknowledged by the user.. [optional]  # noqa: E501
            affected_mo_display_name (str): Display name of the affected object on which the alarm is raised. The name uniquely identifies an alarm target such that it can be distinguished from similar objects managed by Intersight.. [optional]  # noqa: E501
            affected_mo_id (str): MoId of the affected object from the managed system's point of view.. [optional]  # noqa: E501
            affected_mo_type (str): Managed system affected object type. For example Adaptor, FI, CIMC.. [optional]  # noqa: E501
            affected_object (str): A unique key for an alarm instance, consists of a combination of a unique system name and msAffectedObject.. [optional]  # noqa: E501
            ancestor_mo_id (str): Parent MoId of the fault from managed system. For example, Blade moid for adaptor fault.. [optional]  # noqa: E501
            ancestor_mo_type (str): Parent MO type of the fault from managed system. For example, Blade for adaptor fault.. [optional]  # noqa: E501
            code (str): A unique alarm code. For alarms mapped from UCS faults, this will be the same as the UCS fault code.. [optional]  # noqa: E501
            creation_time (datetime): The time the alarm was created.. [optional]  # noqa: E501
            description (str): A longer description of the alarm than the name. The description contains details of the component reporting the issue.. [optional]  # noqa: E501
            last_transition_time (datetime): The time the alarm last had a change in severity.. [optional]  # noqa: E501
            ms_affected_object (str): A unique key for the alarm from the managed system's point of view. For example, in the case of UCS, this is the fault's dn.. [optional]  # noqa: E501
            name (str): Uniquely identifies the type of alarm. For alarms originating from Intersight, this will be a descriptive name. For alarms that are mapped from faults, the name will be derived from fault properties. For example, alarms mapped from UCS faults will use a prefix of UCS and appended with the fault code.. [optional]  # noqa: E501
            orig_severity (str): The original severity when the alarm was first created. * `None` - The Enum value None represents that there is no severity. * `Info` - The Enum value Info represents the Informational level of severity. * `Critical` - The Enum value Critical represents the Critical level of severity. * `Warning` - The Enum value Warning represents the Warning level of severity. * `Cleared` - The Enum value Cleared represents that the alarm severity has been cleared.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            severity (str): The severity of the alarm. Valid values are Critical, Warning, Info, and Cleared. * `None` - The Enum value None represents that there is no severity. * `Info` - The Enum value Info represents the Informational level of severity. * `Critical` - The Enum value Critical represents the Critical level of severity. * `Warning` - The Enum value Warning represents the Warning level of severity. * `Cleared` - The Enum value Cleared represents that the alarm severity has been cleared.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            suppressed (bool): Indicates whether the alarm is marked for suppression or not.. [optional]  # noqa: E501
            affected_mo (MoBaseMoRelationship): [optional]  # noqa: E501
            definition (CondAlarmDefinitionRelationship): [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "cond.Alarm")
        object_type = kwargs.get('object_type', "cond.Alarm")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CondAlarmAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "cond.Alarm", must be one of ["cond.Alarm", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "cond.Alarm", must be one of ["cond.Alarm", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            acknowledge (str): Alarm acknowledgment state. Default value is None. * `None` - The Enum value None represents that the alarm is not acknowledged and is included as part of health status and overall alarm count. * `Acknowledge` - The Enum value Acknowledge represents that the alarm is acknowledged by user. The alarm will be ignored from the health status and overall alarm count.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            acknowledge_by (str): User who acknowledged the alarm.. [optional]  # noqa: E501
            acknowledge_time (datetime): Time at which the alarm was acknowledged by the user.. [optional]  # noqa: E501
            affected_mo_display_name (str): Display name of the affected object on which the alarm is raised. The name uniquely identifies an alarm target such that it can be distinguished from similar objects managed by Intersight.. [optional]  # noqa: E501
            affected_mo_id (str): MoId of the affected object from the managed system's point of view.. [optional]  # noqa: E501
            affected_mo_type (str): Managed system affected object type. For example Adaptor, FI, CIMC.. [optional]  # noqa: E501
            affected_object (str): A unique key for an alarm instance, consists of a combination of a unique system name and msAffectedObject.. [optional]  # noqa: E501
            ancestor_mo_id (str): Parent MoId of the fault from managed system. For example, Blade moid for adaptor fault.. [optional]  # noqa: E501
            ancestor_mo_type (str): Parent MO type of the fault from managed system. For example, Blade for adaptor fault.. [optional]  # noqa: E501
            code (str): A unique alarm code. For alarms mapped from UCS faults, this will be the same as the UCS fault code.. [optional]  # noqa: E501
            creation_time (datetime): The time the alarm was created.. [optional]  # noqa: E501
            description (str): A longer description of the alarm than the name. The description contains details of the component reporting the issue.. [optional]  # noqa: E501
            last_transition_time (datetime): The time the alarm last had a change in severity.. [optional]  # noqa: E501
            ms_affected_object (str): A unique key for the alarm from the managed system's point of view. For example, in the case of UCS, this is the fault's dn.. [optional]  # noqa: E501
            name (str): Uniquely identifies the type of alarm. For alarms originating from Intersight, this will be a descriptive name. For alarms that are mapped from faults, the name will be derived from fault properties. For example, alarms mapped from UCS faults will use a prefix of UCS and appended with the fault code.. [optional]  # noqa: E501
            orig_severity (str): The original severity when the alarm was first created. * `None` - The Enum value None represents that there is no severity. * `Info` - The Enum value Info represents the Informational level of severity. * `Critical` - The Enum value Critical represents the Critical level of severity. * `Warning` - The Enum value Warning represents the Warning level of severity. * `Cleared` - The Enum value Cleared represents that the alarm severity has been cleared.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            severity (str): The severity of the alarm. Valid values are Critical, Warning, Info, and Cleared. * `None` - The Enum value None represents that there is no severity. * `Info` - The Enum value Info represents the Informational level of severity. * `Critical` - The Enum value Critical represents the Critical level of severity. * `Warning` - The Enum value Warning represents the Warning level of severity. * `Cleared` - The Enum value Cleared represents that the alarm severity has been cleared.. [optional] if omitted the server will use the default value of "None"  # noqa: E501
            suppressed (bool): Indicates whether the alarm is marked for suppression or not.. [optional]  # noqa: E501
            affected_mo (MoBaseMoRelationship): [optional]  # noqa: E501
            definition (CondAlarmDefinitionRelationship): [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "cond.Alarm")
        object_type = kwargs.get('object_type', "cond.Alarm")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
