"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.iam_account_relationship import IamAccountRelationship
    from intersight.model.license_customer_op_relationship import LicenseCustomerOpRelationship
    from intersight.model.license_iks_customer_op_relationship import LicenseIksCustomerOpRelationship
    from intersight.model.license_iks_license_count_relationship import LicenseIksLicenseCountRelationship
    from intersight.model.license_inc_customer_op_relationship import LicenseIncCustomerOpRelationship
    from intersight.model.license_inc_license_count_relationship import LicenseIncLicenseCountRelationship
    from intersight.model.license_iwo_customer_op_relationship import LicenseIwoCustomerOpRelationship
    from intersight.model.license_iwo_license_count_relationship import LicenseIwoLicenseCountRelationship
    from intersight.model.license_license_info_relationship import LicenseLicenseInfoRelationship
    from intersight.model.license_license_info_view_relationship import LicenseLicenseInfoViewRelationship
    from intersight.model.license_license_registration_status_relationship import LicenseLicenseRegistrationStatusRelationship
    from intersight.model.license_smartlicense_token_relationship import LicenseSmartlicenseTokenRelationship
    globals()['IamAccountRelationship'] = IamAccountRelationship
    globals()['LicenseCustomerOpRelationship'] = LicenseCustomerOpRelationship
    globals()['LicenseIksCustomerOpRelationship'] = LicenseIksCustomerOpRelationship
    globals()['LicenseIksLicenseCountRelationship'] = LicenseIksLicenseCountRelationship
    globals()['LicenseIncCustomerOpRelationship'] = LicenseIncCustomerOpRelationship
    globals()['LicenseIncLicenseCountRelationship'] = LicenseIncLicenseCountRelationship
    globals()['LicenseIwoCustomerOpRelationship'] = LicenseIwoCustomerOpRelationship
    globals()['LicenseIwoLicenseCountRelationship'] = LicenseIwoLicenseCountRelationship
    globals()['LicenseLicenseInfoRelationship'] = LicenseLicenseInfoRelationship
    globals()['LicenseLicenseInfoViewRelationship'] = LicenseLicenseInfoViewRelationship
    globals()['LicenseLicenseRegistrationStatusRelationship'] = LicenseLicenseRegistrationStatusRelationship
    globals()['LicenseSmartlicenseTokenRelationship'] = LicenseSmartlicenseTokenRelationship


class LicenseAccountLicenseDataAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'LICENSE.ACCOUNTLICENSEDATA': "license.AccountLicenseData",
        },
        ('object_type',): {
            'LICENSE.ACCOUNTLICENSEDATA': "license.AccountLicenseData",
        },
        ('default_license_type',): {
            'BASE': "Base",
            'ESSENTIAL': "Essential",
            'STANDARD': "Standard",
            'ADVANTAGE': "Advantage",
            'PREMIER': "Premier",
            'IWO-ESSENTIAL': "IWO-Essential",
            'IWO-ADVANTAGE': "IWO-Advantage",
            'IWO-PREMIER': "IWO-Premier",
            'IKS-ADVANTAGE': "IKS-Advantage",
            'INC-PREMIER-1GFIXED': "INC-Premier-1GFixed",
            'INC-PREMIER-10GFIXED': "INC-Premier-10GFixed",
            'INC-PREMIER-100GFIXED': "INC-Premier-100GFixed",
            'INC-PREMIER-MOD4SLOT': "INC-Premier-Mod4Slot",
            'INC-PREMIER-MOD8SLOT': "INC-Premier-Mod8Slot",
            'INC-PREMIER-D2OPSFIXED': "INC-Premier-D2OpsFixed",
            'INC-PREMIER-D2OPSMOD': "INC-Premier-D2OpsMod",
            'INC-PREMIER-CENTRALIZEDMOD8SLOT': "INC-Premier-CentralizedMod8Slot",
            'INC-PREMIER-DISTRIBUTEDMOD8SLOT': "INC-Premier-DistributedMod8Slot",
            'INTERSIGHTTRIAL': "IntersightTrial",
            'IWOTRIAL': "IWOTrial",
            'IKSTRIAL': "IKSTrial",
            'INCTRIAL': "INCTrial",
        },
        ('default_license_type_newer_models',): {
            'BASE': "Base",
            'ESSENTIAL': "Essential",
            'STANDARD': "Standard",
            'ADVANTAGE': "Advantage",
            'PREMIER': "Premier",
            'IWO-ESSENTIAL': "IWO-Essential",
            'IWO-ADVANTAGE': "IWO-Advantage",
            'IWO-PREMIER': "IWO-Premier",
            'IKS-ADVANTAGE': "IKS-Advantage",
            'INC-PREMIER-1GFIXED': "INC-Premier-1GFixed",
            'INC-PREMIER-10GFIXED': "INC-Premier-10GFixed",
            'INC-PREMIER-100GFIXED': "INC-Premier-100GFixed",
            'INC-PREMIER-MOD4SLOT': "INC-Premier-Mod4Slot",
            'INC-PREMIER-MOD8SLOT': "INC-Premier-Mod8Slot",
            'INC-PREMIER-D2OPSFIXED': "INC-Premier-D2OpsFixed",
            'INC-PREMIER-D2OPSMOD': "INC-Premier-D2OpsMod",
            'INC-PREMIER-CENTRALIZEDMOD8SLOT': "INC-Premier-CentralizedMod8Slot",
            'INC-PREMIER-DISTRIBUTEDMOD8SLOT': "INC-Premier-DistributedMod8Slot",
            'INTERSIGHTTRIAL': "IntersightTrial",
            'IWOTRIAL': "IWOTrial",
            'IKSTRIAL': "IKSTrial",
            'INCTRIAL': "INCTrial",
        },
        ('highest_compliant_license_tier',): {
            'BASE': "Base",
            'ESSENTIAL': "Essential",
            'STANDARD': "Standard",
            'ADVANTAGE': "Advantage",
            'PREMIER': "Premier",
            'IWO-ESSENTIAL': "IWO-Essential",
            'IWO-ADVANTAGE': "IWO-Advantage",
            'IWO-PREMIER': "IWO-Premier",
            'IKS-ADVANTAGE': "IKS-Advantage",
            'INC-PREMIER-1GFIXED': "INC-Premier-1GFixed",
            'INC-PREMIER-10GFIXED': "INC-Premier-10GFixed",
            'INC-PREMIER-100GFIXED': "INC-Premier-100GFixed",
            'INC-PREMIER-MOD4SLOT': "INC-Premier-Mod4Slot",
            'INC-PREMIER-MOD8SLOT': "INC-Premier-Mod8Slot",
            'INC-PREMIER-D2OPSFIXED': "INC-Premier-D2OpsFixed",
            'INC-PREMIER-D2OPSMOD': "INC-Premier-D2OpsMod",
            'INC-PREMIER-CENTRALIZEDMOD8SLOT': "INC-Premier-CentralizedMod8Slot",
            'INC-PREMIER-DISTRIBUTEDMOD8SLOT': "INC-Premier-DistributedMod8Slot",
            'INTERSIGHTTRIAL': "IntersightTrial",
            'IWOTRIAL': "IWOTrial",
            'IKSTRIAL': "IKSTrial",
            'INCTRIAL': "INCTrial",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'account_id': (str,),  # noqa: E501
            'agent_data': (str,),  # noqa: E501
            'auth_expire_time': (str,),  # noqa: E501
            'auth_initial_time': (str,),  # noqa: E501
            'auth_next_time': (str,),  # noqa: E501
            'category': (str,),  # noqa: E501
            'default_license_type': (str,),  # noqa: E501
            'default_license_type_newer_models': (str,),  # noqa: E501
            'error_desc': (str,),  # noqa: E501
            'group': (str,),  # noqa: E501
            'highest_compliant_license_tier': (str,),  # noqa: E501
            'last_cssm_sync': (datetime,),  # noqa: E501
            'last_renew': (datetime,),  # noqa: E501
            'last_sync': (datetime,),  # noqa: E501
            'last_updated_time': (datetime,),  # noqa: E501
            'license_state': (str,),  # noqa: E501
            'license_tech_support_info': (str,),  # noqa: E501
            'register_expire_time': (str,),  # noqa: E501
            'register_initial_time': (str,),  # noqa: E501
            'register_next_time': (str,),  # noqa: E501
            'registration_status': (str,),  # noqa: E501
            'renew_failure_string': (str,),  # noqa: E501
            'smart_account': (str,),  # noqa: E501
            'smart_account_domain': (str,),  # noqa: E501
            'smart_api_enabled': (bool,),  # noqa: E501
            'smart_api_sync_status': (str,),  # noqa: E501
            'sync_status': (str,),  # noqa: E501
            'virtual_account': (str,),  # noqa: E501
            'account': (IamAccountRelationship,),  # noqa: E501
            'customer_op': (LicenseCustomerOpRelationship,),  # noqa: E501
            'iks_customer_op': (LicenseIksCustomerOpRelationship,),  # noqa: E501
            'iks_license_count': (LicenseIksLicenseCountRelationship,),  # noqa: E501
            'inc_customer_op': (LicenseIncCustomerOpRelationship,),  # noqa: E501
            'inc_license_count': (LicenseIncLicenseCountRelationship,),  # noqa: E501
            'iwo_customer_op': (LicenseIwoCustomerOpRelationship,),  # noqa: E501
            'iwo_license_count': (LicenseIwoLicenseCountRelationship,),  # noqa: E501
            'license_info_view': (LicenseLicenseInfoViewRelationship,),  # noqa: E501
            'license_registration_status': (LicenseLicenseRegistrationStatusRelationship,),  # noqa: E501
            'licenseinfos': ([LicenseLicenseInfoRelationship], none_type,),  # noqa: E501
            'smartlicense_token': (LicenseSmartlicenseTokenRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'account_id': 'AccountId',  # noqa: E501
        'agent_data': 'AgentData',  # noqa: E501
        'auth_expire_time': 'AuthExpireTime',  # noqa: E501
        'auth_initial_time': 'AuthInitialTime',  # noqa: E501
        'auth_next_time': 'AuthNextTime',  # noqa: E501
        'category': 'Category',  # noqa: E501
        'default_license_type': 'DefaultLicenseType',  # noqa: E501
        'default_license_type_newer_models': 'DefaultLicenseTypeNewerModels',  # noqa: E501
        'error_desc': 'ErrorDesc',  # noqa: E501
        'group': 'Group',  # noqa: E501
        'highest_compliant_license_tier': 'HighestCompliantLicenseTier',  # noqa: E501
        'last_cssm_sync': 'LastCssmSync',  # noqa: E501
        'last_renew': 'LastRenew',  # noqa: E501
        'last_sync': 'LastSync',  # noqa: E501
        'last_updated_time': 'LastUpdatedTime',  # noqa: E501
        'license_state': 'LicenseState',  # noqa: E501
        'license_tech_support_info': 'LicenseTechSupportInfo',  # noqa: E501
        'register_expire_time': 'RegisterExpireTime',  # noqa: E501
        'register_initial_time': 'RegisterInitialTime',  # noqa: E501
        'register_next_time': 'RegisterNextTime',  # noqa: E501
        'registration_status': 'RegistrationStatus',  # noqa: E501
        'renew_failure_string': 'RenewFailureString',  # noqa: E501
        'smart_account': 'SmartAccount',  # noqa: E501
        'smart_account_domain': 'SmartAccountDomain',  # noqa: E501
        'smart_api_enabled': 'SmartApiEnabled',  # noqa: E501
        'smart_api_sync_status': 'SmartApiSyncStatus',  # noqa: E501
        'sync_status': 'SyncStatus',  # noqa: E501
        'virtual_account': 'VirtualAccount',  # noqa: E501
        'account': 'Account',  # noqa: E501
        'customer_op': 'CustomerOp',  # noqa: E501
        'iks_customer_op': 'IksCustomerOp',  # noqa: E501
        'iks_license_count': 'IksLicenseCount',  # noqa: E501
        'inc_customer_op': 'IncCustomerOp',  # noqa: E501
        'inc_license_count': 'IncLicenseCount',  # noqa: E501
        'iwo_customer_op': 'IwoCustomerOp',  # noqa: E501
        'iwo_license_count': 'IwoLicenseCount',  # noqa: E501
        'license_info_view': 'LicenseInfoView',  # noqa: E501
        'license_registration_status': 'LicenseRegistrationStatus',  # noqa: E501
        'licenseinfos': 'Licenseinfos',  # noqa: E501
        'smartlicense_token': 'SmartlicenseToken',  # noqa: E501
    }

    read_only_vars = {
        'account_id',  # noqa: E501
        'agent_data',  # noqa: E501
        'auth_expire_time',  # noqa: E501
        'auth_initial_time',  # noqa: E501
        'auth_next_time',  # noqa: E501
        'category',  # noqa: E501
        'error_desc',  # noqa: E501
        'group',  # noqa: E501
        'highest_compliant_license_tier',  # noqa: E501
        'last_cssm_sync',  # noqa: E501
        'last_renew',  # noqa: E501
        'last_sync',  # noqa: E501
        'last_updated_time',  # noqa: E501
        'license_state',  # noqa: E501
        'license_tech_support_info',  # noqa: E501
        'register_expire_time',  # noqa: E501
        'register_initial_time',  # noqa: E501
        'register_next_time',  # noqa: E501
        'registration_status',  # noqa: E501
        'renew_failure_string',  # noqa: E501
        'smart_account',  # noqa: E501
        'smart_account_domain',  # noqa: E501
        'smart_api_enabled',  # noqa: E501
        'smart_api_sync_status',  # noqa: E501
        'sync_status',  # noqa: E501
        'virtual_account',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """LicenseAccountLicenseDataAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "license.AccountLicenseData", must be one of ["license.AccountLicenseData", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "license.AccountLicenseData", must be one of ["license.AccountLicenseData", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_id (str): Root user's ID of the account.. [optional]  # noqa: E501
            agent_data (str): Agent trusted store data.. [optional]  # noqa: E501
            auth_expire_time (str): Authorization expiration time.. [optional]  # noqa: E501
            auth_initial_time (str): Intial authorization time.. [optional]  # noqa: E501
            auth_next_time (str): Next time for the authorization.. [optional]  # noqa: E501
            category (str): Account license data category name.. [optional]  # noqa: E501
            default_license_type (str): Default license tier set by the user. * `Base` - Base as a License type. It is default license type. * `Essential` - Essential as a License type. * `Standard` - Standard as a License type. * `Advantage` - Advantage as a License type. * `Premier` - Premier as a License type. * `IWO-Essential` - IWO-Essential as a License type. * `IWO-Advantage` - IWO-Advantage as a License type. * `IWO-Premier` - IWO-Premier as a License type. * `IKS-Advantage` - IKS-Advantage as a License type. * `INC-Premier-1GFixed` - Premier 1G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-10GFixed` - Premier 10G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-100GFixed` - Premier 100G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-Mod4Slot` - Premier Modular 4 slot license tier for Intersight Nexus Cloud. * `INC-Premier-Mod8Slot` - Premier Modular 8 slot license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsFixed` - Premier D2Ops fixed license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsMod` - Premier D2Ops modular license tier for Intersight Nexus Cloud. * `INC-Premier-CentralizedMod8Slot` - Premier modular license tier of switch type CentralizedMod8Slot for Intersight Nexus Cloud. * `INC-Premier-DistributedMod8Slot` - Premier modular license tier of switch type DistributedMod8Slot for Intersight Nexus Cloud. * `IntersightTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Intersight tiers. * `IWOTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IKS tiers. * `IKSTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IWO tiers. * `INCTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Nexus tiers.. [optional] if omitted the server will use the default value of "Base"  # noqa: E501
            default_license_type_newer_models (str): Default license tier for newer model M7+ servers set by the user. * `Base` - Base as a License type. It is default license type. * `Essential` - Essential as a License type. * `Standard` - Standard as a License type. * `Advantage` - Advantage as a License type. * `Premier` - Premier as a License type. * `IWO-Essential` - IWO-Essential as a License type. * `IWO-Advantage` - IWO-Advantage as a License type. * `IWO-Premier` - IWO-Premier as a License type. * `IKS-Advantage` - IKS-Advantage as a License type. * `INC-Premier-1GFixed` - Premier 1G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-10GFixed` - Premier 10G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-100GFixed` - Premier 100G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-Mod4Slot` - Premier Modular 4 slot license tier for Intersight Nexus Cloud. * `INC-Premier-Mod8Slot` - Premier Modular 8 slot license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsFixed` - Premier D2Ops fixed license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsMod` - Premier D2Ops modular license tier for Intersight Nexus Cloud. * `INC-Premier-CentralizedMod8Slot` - Premier modular license tier of switch type CentralizedMod8Slot for Intersight Nexus Cloud. * `INC-Premier-DistributedMod8Slot` - Premier modular license tier of switch type DistributedMod8Slot for Intersight Nexus Cloud. * `IntersightTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Intersight tiers. * `IWOTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IKS tiers. * `IKSTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IWO tiers. * `INCTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Nexus tiers.. [optional] if omitted the server will use the default value of "Base"  # noqa: E501
            error_desc (str): The detailed error message when there is any error related to license sync of this account.. [optional]  # noqa: E501
            group (str): Account license data group name.. [optional]  # noqa: E501
            highest_compliant_license_tier (str): The highest license tier which is in compliant of this account. * `Base` - Base as a License type. It is default license type. * `Essential` - Essential as a License type. * `Standard` - Standard as a License type. * `Advantage` - Advantage as a License type. * `Premier` - Premier as a License type. * `IWO-Essential` - IWO-Essential as a License type. * `IWO-Advantage` - IWO-Advantage as a License type. * `IWO-Premier` - IWO-Premier as a License type. * `IKS-Advantage` - IKS-Advantage as a License type. * `INC-Premier-1GFixed` - Premier 1G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-10GFixed` - Premier 10G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-100GFixed` - Premier 100G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-Mod4Slot` - Premier Modular 4 slot license tier for Intersight Nexus Cloud. * `INC-Premier-Mod8Slot` - Premier Modular 8 slot license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsFixed` - Premier D2Ops fixed license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsMod` - Premier D2Ops modular license tier for Intersight Nexus Cloud. * `INC-Premier-CentralizedMod8Slot` - Premier modular license tier of switch type CentralizedMod8Slot for Intersight Nexus Cloud. * `INC-Premier-DistributedMod8Slot` - Premier modular license tier of switch type DistributedMod8Slot for Intersight Nexus Cloud. * `IntersightTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Intersight tiers. * `IWOTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IKS tiers. * `IKSTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IWO tiers. * `INCTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Nexus tiers.. [optional] if omitted the server will use the default value of "Base"  # noqa: E501
            last_cssm_sync (datetime): Specifies last sync time with CSSM.. [optional]  # noqa: E501
            last_renew (datetime): Specifies last certificate renew time with SA.. [optional]  # noqa: E501
            last_sync (datetime): Specifies last sync time with SA.. [optional]  # noqa: E501
            last_updated_time (datetime): Record's last update datetime.. [optional]  # noqa: E501
            license_state (str): Aggregrated mode for the agent.. [optional]  # noqa: E501
            license_tech_support_info (str): Tech-support info of a smart-agent.. [optional]  # noqa: E501
            register_expire_time (str): Registration exipiration time.. [optional]  # noqa: E501
            register_initial_time (str): Initial time of registration.. [optional]  # noqa: E501
            register_next_time (str): Next time for the license registration.. [optional]  # noqa: E501
            registration_status (str): Registration status of a smart-agent.. [optional]  # noqa: E501
            renew_failure_string (str): License renewal failure message.. [optional]  # noqa: E501
            smart_account (str): Name of the smart account.. [optional]  # noqa: E501
            smart_account_domain (str): Domain Name of the smart account.. [optional]  # noqa: E501
            smart_api_enabled (bool): Indicate whether API integration is enabled.. [optional]  # noqa: E501
            smart_api_sync_status (str): The detailed error message when there is any smart API sync error related to this account.. [optional]  # noqa: E501
            sync_status (str): Current sync status for the account.. [optional]  # noqa: E501
            virtual_account (str): Name of the virtual account.. [optional]  # noqa: E501
            account (IamAccountRelationship): [optional]  # noqa: E501
            customer_op (LicenseCustomerOpRelationship): [optional]  # noqa: E501
            iks_customer_op (LicenseIksCustomerOpRelationship): [optional]  # noqa: E501
            iks_license_count (LicenseIksLicenseCountRelationship): [optional]  # noqa: E501
            inc_customer_op (LicenseIncCustomerOpRelationship): [optional]  # noqa: E501
            inc_license_count (LicenseIncLicenseCountRelationship): [optional]  # noqa: E501
            iwo_customer_op (LicenseIwoCustomerOpRelationship): [optional]  # noqa: E501
            iwo_license_count (LicenseIwoLicenseCountRelationship): [optional]  # noqa: E501
            license_info_view (LicenseLicenseInfoViewRelationship): [optional]  # noqa: E501
            license_registration_status (LicenseLicenseRegistrationStatusRelationship): [optional]  # noqa: E501
            licenseinfos ([LicenseLicenseInfoRelationship], none_type): An array of relationships to licenseLicenseInfo resources.. [optional]  # noqa: E501
            smartlicense_token (LicenseSmartlicenseTokenRelationship): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "license.AccountLicenseData")
        object_type = kwargs.get('object_type', "license.AccountLicenseData")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """LicenseAccountLicenseDataAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "license.AccountLicenseData", must be one of ["license.AccountLicenseData", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "license.AccountLicenseData", must be one of ["license.AccountLicenseData", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_id (str): Root user's ID of the account.. [optional]  # noqa: E501
            agent_data (str): Agent trusted store data.. [optional]  # noqa: E501
            auth_expire_time (str): Authorization expiration time.. [optional]  # noqa: E501
            auth_initial_time (str): Intial authorization time.. [optional]  # noqa: E501
            auth_next_time (str): Next time for the authorization.. [optional]  # noqa: E501
            category (str): Account license data category name.. [optional]  # noqa: E501
            default_license_type (str): Default license tier set by the user. * `Base` - Base as a License type. It is default license type. * `Essential` - Essential as a License type. * `Standard` - Standard as a License type. * `Advantage` - Advantage as a License type. * `Premier` - Premier as a License type. * `IWO-Essential` - IWO-Essential as a License type. * `IWO-Advantage` - IWO-Advantage as a License type. * `IWO-Premier` - IWO-Premier as a License type. * `IKS-Advantage` - IKS-Advantage as a License type. * `INC-Premier-1GFixed` - Premier 1G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-10GFixed` - Premier 10G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-100GFixed` - Premier 100G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-Mod4Slot` - Premier Modular 4 slot license tier for Intersight Nexus Cloud. * `INC-Premier-Mod8Slot` - Premier Modular 8 slot license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsFixed` - Premier D2Ops fixed license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsMod` - Premier D2Ops modular license tier for Intersight Nexus Cloud. * `INC-Premier-CentralizedMod8Slot` - Premier modular license tier of switch type CentralizedMod8Slot for Intersight Nexus Cloud. * `INC-Premier-DistributedMod8Slot` - Premier modular license tier of switch type DistributedMod8Slot for Intersight Nexus Cloud. * `IntersightTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Intersight tiers. * `IWOTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IKS tiers. * `IKSTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IWO tiers. * `INCTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Nexus tiers.. [optional] if omitted the server will use the default value of "Base"  # noqa: E501
            default_license_type_newer_models (str): Default license tier for newer model M7+ servers set by the user. * `Base` - Base as a License type. It is default license type. * `Essential` - Essential as a License type. * `Standard` - Standard as a License type. * `Advantage` - Advantage as a License type. * `Premier` - Premier as a License type. * `IWO-Essential` - IWO-Essential as a License type. * `IWO-Advantage` - IWO-Advantage as a License type. * `IWO-Premier` - IWO-Premier as a License type. * `IKS-Advantage` - IKS-Advantage as a License type. * `INC-Premier-1GFixed` - Premier 1G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-10GFixed` - Premier 10G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-100GFixed` - Premier 100G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-Mod4Slot` - Premier Modular 4 slot license tier for Intersight Nexus Cloud. * `INC-Premier-Mod8Slot` - Premier Modular 8 slot license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsFixed` - Premier D2Ops fixed license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsMod` - Premier D2Ops modular license tier for Intersight Nexus Cloud. * `INC-Premier-CentralizedMod8Slot` - Premier modular license tier of switch type CentralizedMod8Slot for Intersight Nexus Cloud. * `INC-Premier-DistributedMod8Slot` - Premier modular license tier of switch type DistributedMod8Slot for Intersight Nexus Cloud. * `IntersightTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Intersight tiers. * `IWOTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IKS tiers. * `IKSTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IWO tiers. * `INCTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Nexus tiers.. [optional] if omitted the server will use the default value of "Base"  # noqa: E501
            error_desc (str): The detailed error message when there is any error related to license sync of this account.. [optional]  # noqa: E501
            group (str): Account license data group name.. [optional]  # noqa: E501
            highest_compliant_license_tier (str): The highest license tier which is in compliant of this account. * `Base` - Base as a License type. It is default license type. * `Essential` - Essential as a License type. * `Standard` - Standard as a License type. * `Advantage` - Advantage as a License type. * `Premier` - Premier as a License type. * `IWO-Essential` - IWO-Essential as a License type. * `IWO-Advantage` - IWO-Advantage as a License type. * `IWO-Premier` - IWO-Premier as a License type. * `IKS-Advantage` - IKS-Advantage as a License type. * `INC-Premier-1GFixed` - Premier 1G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-10GFixed` - Premier 10G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-100GFixed` - Premier 100G Fixed license tier for Intersight Nexus Cloud. * `INC-Premier-Mod4Slot` - Premier Modular 4 slot license tier for Intersight Nexus Cloud. * `INC-Premier-Mod8Slot` - Premier Modular 8 slot license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsFixed` - Premier D2Ops fixed license tier for Intersight Nexus Cloud. * `INC-Premier-D2OpsMod` - Premier D2Ops modular license tier for Intersight Nexus Cloud. * `INC-Premier-CentralizedMod8Slot` - Premier modular license tier of switch type CentralizedMod8Slot for Intersight Nexus Cloud. * `INC-Premier-DistributedMod8Slot` - Premier modular license tier of switch type DistributedMod8Slot for Intersight Nexus Cloud. * `IntersightTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Intersight tiers. * `IWOTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IKS tiers. * `IKSTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode IWO tiers. * `INCTrial` - Virtual dummy license type to indicate trial. Used for UI display of trial mode Nexus tiers.. [optional] if omitted the server will use the default value of "Base"  # noqa: E501
            last_cssm_sync (datetime): Specifies last sync time with CSSM.. [optional]  # noqa: E501
            last_renew (datetime): Specifies last certificate renew time with SA.. [optional]  # noqa: E501
            last_sync (datetime): Specifies last sync time with SA.. [optional]  # noqa: E501
            last_updated_time (datetime): Record's last update datetime.. [optional]  # noqa: E501
            license_state (str): Aggregrated mode for the agent.. [optional]  # noqa: E501
            license_tech_support_info (str): Tech-support info of a smart-agent.. [optional]  # noqa: E501
            register_expire_time (str): Registration exipiration time.. [optional]  # noqa: E501
            register_initial_time (str): Initial time of registration.. [optional]  # noqa: E501
            register_next_time (str): Next time for the license registration.. [optional]  # noqa: E501
            registration_status (str): Registration status of a smart-agent.. [optional]  # noqa: E501
            renew_failure_string (str): License renewal failure message.. [optional]  # noqa: E501
            smart_account (str): Name of the smart account.. [optional]  # noqa: E501
            smart_account_domain (str): Domain Name of the smart account.. [optional]  # noqa: E501
            smart_api_enabled (bool): Indicate whether API integration is enabled.. [optional]  # noqa: E501
            smart_api_sync_status (str): The detailed error message when there is any smart API sync error related to this account.. [optional]  # noqa: E501
            sync_status (str): Current sync status for the account.. [optional]  # noqa: E501
            virtual_account (str): Name of the virtual account.. [optional]  # noqa: E501
            account (IamAccountRelationship): [optional]  # noqa: E501
            customer_op (LicenseCustomerOpRelationship): [optional]  # noqa: E501
            iks_customer_op (LicenseIksCustomerOpRelationship): [optional]  # noqa: E501
            iks_license_count (LicenseIksLicenseCountRelationship): [optional]  # noqa: E501
            inc_customer_op (LicenseIncCustomerOpRelationship): [optional]  # noqa: E501
            inc_license_count (LicenseIncLicenseCountRelationship): [optional]  # noqa: E501
            iwo_customer_op (LicenseIwoCustomerOpRelationship): [optional]  # noqa: E501
            iwo_license_count (LicenseIwoLicenseCountRelationship): [optional]  # noqa: E501
            license_info_view (LicenseLicenseInfoViewRelationship): [optional]  # noqa: E501
            license_registration_status (LicenseLicenseRegistrationStatusRelationship): [optional]  # noqa: E501
            licenseinfos ([LicenseLicenseInfoRelationship], none_type): An array of relationships to licenseLicenseInfo resources.. [optional]  # noqa: E501
            smartlicense_token (LicenseSmartlicenseTokenRelationship): [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "license.AccountLicenseData")
        object_type = kwargs.get('object_type', "license.AccountLicenseData")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
