"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError



class MetaPropDefinitionAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'META.PROPDEFINITION': "meta.PropDefinition",
        },
        ('object_type',): {
            'META.PROPDEFINITION': "meta.PropDefinition",
        },
        ('api_access',): {
            'NOACCESS': "NoAccess",
            'READONLY': "ReadOnly",
            'CREATEONLY': "CreateOnly",
            'READWRITE': "ReadWrite",
            'WRITEONLY': "WriteOnly",
            'READONCREATE': "ReadOnCreate",
        },
        ('kind',): {
            'UNKNOWN': "Unknown",
            'BOOLEAN': "Boolean",
            'STRING': "String",
            'INTEGER': "Integer",
            'INT32': "Int32",
            'INT64': "Int64",
            'FLOAT': "Float",
            'DOUBLE': "Double",
            'DATE': "Date",
            'DURATION': "Duration",
            'TIME': "Time",
            'JSON': "Json",
            'BINARY': "Binary",
            'ENUMSTRING': "EnumString",
            'ENUMINTEGER': "EnumInteger",
            'COMPLEXTYPE': "ComplexType",
        },
        ('op_security',): {
            'CLEARTEXT': "ClearText",
            'ENCRYPTED': "Encrypted",
            'PBKDF2': "Pbkdf2",
            'BCRYPT': "Bcrypt",
            'SHA512CRYPT': "Sha512crypt",
            'ARGON2ID': "Argon2id",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'api_access': (str,),  # noqa: E501
            'default': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'is_collection': (bool,),  # noqa: E501
            'is_complex_type': (bool,),  # noqa: E501
            'kind': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'op_security': (str,),  # noqa: E501
            'search_weight': (float,),  # noqa: E501
            'type': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'api_access': 'ApiAccess',  # noqa: E501
        'default': 'Default',  # noqa: E501
        'is_collection': 'IsCollection',  # noqa: E501
        'is_complex_type': 'IsComplexType',  # noqa: E501
        'kind': 'Kind',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'op_security': 'OpSecurity',  # noqa: E501
        'search_weight': 'SearchWeight',  # noqa: E501
        'type': 'Type',  # noqa: E501
    }

    read_only_vars = {
        'api_access',  # noqa: E501
        'is_collection',  # noqa: E501
        'is_complex_type',  # noqa: E501
        'kind',  # noqa: E501
        'name',  # noqa: E501
        'op_security',  # noqa: E501
        'search_weight',  # noqa: E501
        'type',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """MetaPropDefinitionAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "meta.PropDefinition", must be one of ["meta.PropDefinition", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "meta.PropDefinition", must be one of ["meta.PropDefinition", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            api_access (str): API access control for the property. Examples are NoAccess, ReadOnly, CreateOnly etc. * `NoAccess` - The property is not accessible from the API. * `ReadOnly` - The value of the property is read-only.An HTTP 4xx status code is returned when the user sends a POST/PUT/PATCH request that containsa ReadOnly property. * `CreateOnly` - The value of the property can be set when the REST resource is created. It cannot be changed after object creation.An HTTP 4xx status code is returned when the user sends a POST/PUT/PATCH request that containsa CreateOnly property.CreateOnly properties are returned in the response body of HTTP GET requests. * `ReadWrite` - The property has read/write access. * `WriteOnly` - The value of the property can be set but it is never returned in the response body of supported HTTP methods.This settings is used for sensitive properties such as passwords. * `ReadOnCreate` - The value of the property is returned in the HTTP POST response body when the REST resource is created.The property is not writeable and cannot be queried through a GET request after the resource has been created.. [optional] if omitted the server will use the default value of "NoAccess"  # noqa: E501
            default (bool, date, datetime, dict, float, int, list, str, none_type): The default value of the property. Not applicable when IsComplexType is True.. [optional]  # noqa: E501
            is_collection (bool): Indicates whether the property is a collection (i.e. a JSON array), otherwise it is a single value.. [optional]  # noqa: E501
            is_complex_type (bool): Indicates whether the property is a complex type, otherwise it is a basic scalar type.. [optional]  # noqa: E501
            kind (str): The kind of the property. * `Unknown` - The property kind is unknown. * `Boolean` - The 'Boolean' kind of property. * `String` - The 'String' kind of property. * `Integer` - The 'Integer' kind of property. * `Int32` - The 'Int32' kind of property. * `Int64` - The 'Int64' kind of property. * `Float` - The 'Float' kind of property. * `Double` - The 'Double' kind of property. * `Date` - The 'Date' kind of property. * `Duration` - The 'Duration' kind of property. * `Time` - The 'Time' kind of property. * `Json` - The 'JSON' kind of property. * `Binary` - The 'Binary' kind of property. * `EnumString` - The 'EnumString' kind of property. * `EnumInteger` - The 'EnumInteger' kind of property. * `ComplexType` - The 'ComplexType' kind of property.. [optional] if omitted the server will use the default value of "Unknown"  # noqa: E501
            name (str): The name of the property.. [optional]  # noqa: E501
            op_security (str): The data-at-rest security protection applied to this property when a Managed Object is persisted. For example, Encrypted or Cleartext. * `ClearText` - Data at rest is not encrypted using account specific keys.Note that data is always protected using volume encryption. ClearText propertiesare queryable and searchable. * `Encrypted` - The value of the property is encrypted with account-specific cryptographic keys.This setting is used for properties that contain sensitive data. Encrypted propertiesare not queryable and searchable. * `Pbkdf2` - The value of the property is hashed using the pbkdf2 key derivation functions thattakes a password, a salt, and a cost factor as inputs then generates a password hash.Its purpose is to make each password guessing trial by an attacker who has obtaineda password hash file expensive and therefore the cost of a guessing attack high or prohibitive. * `Bcrypt` - The value of the property is hashed using the bcrypt key derivation function. * `Sha512crypt` - The value of the property is hashed using the sha512crypt key derivation function. * `Argon2id` - The value of the property is hashed using the argon2id key derivation function.. [optional] if omitted the server will use the default value of "ClearText"  # noqa: E501
            search_weight (float): Enables the property to be searchable from global search. A value of 0 means this property is not globally searchable.. [optional]  # noqa: E501
            type (str): The type of the property. In case of collection properties the type is that of individual elements.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "meta.PropDefinition")
        object_type = kwargs.get('object_type', "meta.PropDefinition")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """MetaPropDefinitionAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "meta.PropDefinition", must be one of ["meta.PropDefinition", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "meta.PropDefinition", must be one of ["meta.PropDefinition", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            api_access (str): API access control for the property. Examples are NoAccess, ReadOnly, CreateOnly etc. * `NoAccess` - The property is not accessible from the API. * `ReadOnly` - The value of the property is read-only.An HTTP 4xx status code is returned when the user sends a POST/PUT/PATCH request that containsa ReadOnly property. * `CreateOnly` - The value of the property can be set when the REST resource is created. It cannot be changed after object creation.An HTTP 4xx status code is returned when the user sends a POST/PUT/PATCH request that containsa CreateOnly property.CreateOnly properties are returned in the response body of HTTP GET requests. * `ReadWrite` - The property has read/write access. * `WriteOnly` - The value of the property can be set but it is never returned in the response body of supported HTTP methods.This settings is used for sensitive properties such as passwords. * `ReadOnCreate` - The value of the property is returned in the HTTP POST response body when the REST resource is created.The property is not writeable and cannot be queried through a GET request after the resource has been created.. [optional] if omitted the server will use the default value of "NoAccess"  # noqa: E501
            default (bool, date, datetime, dict, float, int, list, str, none_type): The default value of the property. Not applicable when IsComplexType is True.. [optional]  # noqa: E501
            is_collection (bool): Indicates whether the property is a collection (i.e. a JSON array), otherwise it is a single value.. [optional]  # noqa: E501
            is_complex_type (bool): Indicates whether the property is a complex type, otherwise it is a basic scalar type.. [optional]  # noqa: E501
            kind (str): The kind of the property. * `Unknown` - The property kind is unknown. * `Boolean` - The 'Boolean' kind of property. * `String` - The 'String' kind of property. * `Integer` - The 'Integer' kind of property. * `Int32` - The 'Int32' kind of property. * `Int64` - The 'Int64' kind of property. * `Float` - The 'Float' kind of property. * `Double` - The 'Double' kind of property. * `Date` - The 'Date' kind of property. * `Duration` - The 'Duration' kind of property. * `Time` - The 'Time' kind of property. * `Json` - The 'JSON' kind of property. * `Binary` - The 'Binary' kind of property. * `EnumString` - The 'EnumString' kind of property. * `EnumInteger` - The 'EnumInteger' kind of property. * `ComplexType` - The 'ComplexType' kind of property.. [optional] if omitted the server will use the default value of "Unknown"  # noqa: E501
            name (str): The name of the property.. [optional]  # noqa: E501
            op_security (str): The data-at-rest security protection applied to this property when a Managed Object is persisted. For example, Encrypted or Cleartext. * `ClearText` - Data at rest is not encrypted using account specific keys.Note that data is always protected using volume encryption. ClearText propertiesare queryable and searchable. * `Encrypted` - The value of the property is encrypted with account-specific cryptographic keys.This setting is used for properties that contain sensitive data. Encrypted propertiesare not queryable and searchable. * `Pbkdf2` - The value of the property is hashed using the pbkdf2 key derivation functions thattakes a password, a salt, and a cost factor as inputs then generates a password hash.Its purpose is to make each password guessing trial by an attacker who has obtaineda password hash file expensive and therefore the cost of a guessing attack high or prohibitive. * `Bcrypt` - The value of the property is hashed using the bcrypt key derivation function. * `Sha512crypt` - The value of the property is hashed using the sha512crypt key derivation function. * `Argon2id` - The value of the property is hashed using the argon2id key derivation function.. [optional] if omitted the server will use the default value of "ClearText"  # noqa: E501
            search_weight (float): Enables the property to be searchable from global search. A value of 0 means this property is not globally searchable.. [optional]  # noqa: E501
            type (str): The type of the property. In case of collection properties the type is that of individual elements.. [optional]  # noqa: E501
        """

        class_id = kwargs.get('class_id', "meta.PropDefinition")
        object_type = kwargs.get('object_type', "meta.PropDefinition")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
