"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-14628
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError



class StorageNetAppBaseIpInterfaceAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'NETAPPDATAIPINTERFACE': "storage.NetAppDataIpInterface",
            'NETAPPNONDATAIPINTERFACE': "storage.NetAppNonDataIpInterface",
        },
        ('object_type',): {
            'NETAPPDATAIPINTERFACE': "storage.NetAppDataIpInterface",
            'NETAPPNONDATAIPINTERFACE': "storage.NetAppNonDataIpInterface",
        },
        ('interface_state',): {
            'DOWN': "Down",
            'UP': "Up",
        },
        ('ip_family',): {
            'IPV4': "IPv4",
            'IPV6': "IPv6",
        },
        ('state',): {
            'DOWN': "down",
            'UP': "up",
            'PRESENT': "present",
        },
    }

    validations = {
        ('service_policy_uuid',): {
            'regex': {
                'pattern': r'^$|^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$',  # noqa: E501
            },
        },
        ('uuid',): {
            'regex': {
                'pattern': r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$',  # noqa: E501
            },
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'current_node': (str,),  # noqa: E501
            'current_port': (str,),  # noqa: E501
            'enabled': (str,),  # noqa: E501
            'home_node': (str,),  # noqa: E501
            'home_port': (str,),  # noqa: E501
            'interface_is_home': (str,),  # noqa: E501
            'interface_state': (str,),  # noqa: E501
            'ip_address': (str,),  # noqa: E501
            'ip_family': (str,),  # noqa: E501
            'ipspace': (str,),  # noqa: E501
            'is_home': (bool,),  # noqa: E501
            'location_failover': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'netmask': (str,),  # noqa: E501
            'service_policy_name': (str,),  # noqa: E501
            'service_policy_uuid': (str,),  # noqa: E501
            'services': ([str], none_type,),  # noqa: E501
            'state': (str,),  # noqa: E501
            'svm_name': (str,),  # noqa: E501
            'uuid': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'current_node': 'CurrentNode',  # noqa: E501
        'current_port': 'CurrentPort',  # noqa: E501
        'enabled': 'Enabled',  # noqa: E501
        'home_node': 'HomeNode',  # noqa: E501
        'home_port': 'HomePort',  # noqa: E501
        'interface_is_home': 'InterfaceIsHome',  # noqa: E501
        'interface_state': 'InterfaceState',  # noqa: E501
        'ip_address': 'IpAddress',  # noqa: E501
        'ip_family': 'IpFamily',  # noqa: E501
        'ipspace': 'Ipspace',  # noqa: E501
        'is_home': 'IsHome',  # noqa: E501
        'location_failover': 'LocationFailover',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'netmask': 'Netmask',  # noqa: E501
        'service_policy_name': 'ServicePolicyName',  # noqa: E501
        'service_policy_uuid': 'ServicePolicyUuid',  # noqa: E501
        'services': 'Services',  # noqa: E501
        'state': 'State',  # noqa: E501
        'svm_name': 'SvmName',  # noqa: E501
        'uuid': 'Uuid',  # noqa: E501
    }

    read_only_vars = {
        'current_node',  # noqa: E501
        'current_port',  # noqa: E501
        'enabled',  # noqa: E501
        'home_node',  # noqa: E501
        'home_port',  # noqa: E501
        'interface_is_home',  # noqa: E501
        'interface_state',  # noqa: E501
        'ip_address',  # noqa: E501
        'ip_family',  # noqa: E501
        'ipspace',  # noqa: E501
        'is_home',  # noqa: E501
        'location_failover',  # noqa: E501
        'name',  # noqa: E501
        'netmask',  # noqa: E501
        'service_policy_name',  # noqa: E501
        'service_policy_uuid',  # noqa: E501
        'state',  # noqa: E501
        'svm_name',  # noqa: E501
        'uuid',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, class_id, object_type, *args, **kwargs):  # noqa: E501
        """StorageNetAppBaseIpInterfaceAllOf - a model defined in OpenAPI

        Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data. The enum values provides the list of concrete types that can be instantiated from this abstract type.
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property. The enum values provides the list of concrete types that can be instantiated from this abstract type.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            current_node (str): Name of the current node of IP interface.. [optional]  # noqa: E501
            current_port (str): Name of the current port of IP interface.. [optional]  # noqa: E501
            enabled (str): IP interface is enabled or not.. [optional]  # noqa: E501
            home_node (str): Name of home node of IP interface.. [optional]  # noqa: E501
            home_port (str): Name of home port of IP interface.. [optional]  # noqa: E501
            interface_is_home (str): Reports whether the IP interface is home or has failed over to its HA peer.. [optional]  # noqa: E501
            interface_state (str): The state of the IP interface. * `Down` - The state is set to down if the interface is not enabled. * `Up` - The state is set to up if the interface is enabled.. [optional] if omitted the server will use the default value of "Down"  # noqa: E501
            ip_address (str): The IP address of interface.. [optional]  # noqa: E501
            ip_family (str): IP address family of interface. * `IPv4` - IP address family type is IPv4. * `IPv6` - IP address family type is IP6.. [optional] if omitted the server will use the default value of "IPv4"  # noqa: E501
            ipspace (str): The name of the IPspace of the IP interface.. [optional]  # noqa: E501
            is_home (bool): Reports whether the IP interface is home or has failed over to its HA peer.. [optional]  # noqa: E501
            location_failover (str): Defines where an interface may failover, [ home_port_only, default, home_node_only, sfo_partners_only, broadcast_domain_only ].. [optional]  # noqa: E501
            name (str): The name of the IP interface.. [optional]  # noqa: E501
            netmask (str): The netmask of the interface.. [optional]  # noqa: E501
            service_policy_name (str): Service policy name of IP interface.. [optional]  # noqa: E501
            service_policy_uuid (str): Service policy UUID of IP interface.. [optional]  # noqa: E501
            services ([str], none_type): [optional]  # noqa: E501
            state (str): The state of the IP interface. * `down` - An inactive port is listed as Down. * `up` - An active port is listed as Up. * `present` - An active port is listed as present.. [optional] if omitted the server will use the default value of "down"  # noqa: E501
            svm_name (str): The storage virtual machine name for the interface.. [optional]  # noqa: E501
            uuid (str): Uuid of NetApp IP Interface.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, class_id, object_type, *args, **kwargs):  # noqa: E501
        """StorageNetAppBaseIpInterfaceAllOf - a model defined in OpenAPI

        Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data. The enum values provides the list of concrete types that can be instantiated from this abstract type.
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property. The enum values provides the list of concrete types that can be instantiated from this abstract type.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            current_node (str): Name of the current node of IP interface.. [optional]  # noqa: E501
            current_port (str): Name of the current port of IP interface.. [optional]  # noqa: E501
            enabled (str): IP interface is enabled or not.. [optional]  # noqa: E501
            home_node (str): Name of home node of IP interface.. [optional]  # noqa: E501
            home_port (str): Name of home port of IP interface.. [optional]  # noqa: E501
            interface_is_home (str): Reports whether the IP interface is home or has failed over to its HA peer.. [optional]  # noqa: E501
            interface_state (str): The state of the IP interface. * `Down` - The state is set to down if the interface is not enabled. * `Up` - The state is set to up if the interface is enabled.. [optional] if omitted the server will use the default value of "Down"  # noqa: E501
            ip_address (str): The IP address of interface.. [optional]  # noqa: E501
            ip_family (str): IP address family of interface. * `IPv4` - IP address family type is IPv4. * `IPv6` - IP address family type is IP6.. [optional] if omitted the server will use the default value of "IPv4"  # noqa: E501
            ipspace (str): The name of the IPspace of the IP interface.. [optional]  # noqa: E501
            is_home (bool): Reports whether the IP interface is home or has failed over to its HA peer.. [optional]  # noqa: E501
            location_failover (str): Defines where an interface may failover, [ home_port_only, default, home_node_only, sfo_partners_only, broadcast_domain_only ].. [optional]  # noqa: E501
            name (str): The name of the IP interface.. [optional]  # noqa: E501
            netmask (str): The netmask of the interface.. [optional]  # noqa: E501
            service_policy_name (str): Service policy name of IP interface.. [optional]  # noqa: E501
            service_policy_uuid (str): Service policy UUID of IP interface.. [optional]  # noqa: E501
            services ([str], none_type): [optional]  # noqa: E501
            state (str): The state of the IP interface. * `down` - An inactive port is listed as Down. * `up` - An active port is listed as Up. * `present` - An active port is listed as present.. [optional] if omitted the server will use the default value of "down"  # noqa: E501
            svm_name (str): The storage virtual machine name for the interface.. [optional]  # noqa: E501
            uuid (str): Uuid of NetApp IP Interface.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
